<?php

use Brickrouge\A;
use Brickrouge\Element;
use Brickrouge\Form;
use Brickrouge\Text;
use Brickrouge\Widget\PopImage;

class trio_WdEditorElement extends WdEditorElement
{
	public function __construct($tags)
	{
		parent::__construct
		(
			'div', $tags + array
			(
				Element::CHILDREN => array
				(
					'body' => new moo_WdEditorElement
					(
						array
						(
//							'rows' => 5
						)
					),

					'imageid1' => new PopImage
					(
						array
						(
							'style' => 'vertical-align: middle'
						)
					),

					'imageid2' => new PopImage
					(
						array
						(
							'style' => 'vertical-align: middle'
						)
					),

					'imageid3' => new PopImage
					(
						array
						(
							'style' => 'vertical-align: middle'
						)
					),

					'label1' => new Text
					(

					),

					'label2' => new Text
					(

					),

					'label3' => new Text
					(

					)
				),

				'class' => 'clearfix',
				'style' => 'margin-bottom: 0'
			)
		);
	}

	public function offsetSet($offset, $value)
	{
		parent::offsetSet($offset, $value);

		if ($offset == 'value')
		{
			if (is_string($value))
			{
				$value = json_decode($value, true);
			}

			foreach ($this->children as $id => $child)
			{
				$child['value'] = isset($value[$id]) ? $value[$id] : null;
			}
		}
		else if ($offset == 'name')
		{
			foreach ($this->children as $id => $child)
			{
				$child['name'] = "{$value}[$id]";
			}
		}
	}

	protected function render_inner_html()
	{
		$children = $this->children;

		return <<<EOT
{$children['body']}

<div style="margin-top: 16px; text-align: center">
	<div style="display: inline-block"><div style="margin-bottom: 8px">{$children['imageid1']}</div>{$children['label1']}</div>
	<div style="display: inline-block; margin-left: 16px"><div style="margin-bottom: 8px">{$children['imageid2']}</div>{$children['label2']}</div>
	<div style="display: inline-block; margin-left: 16px"><div style="margin-bottom: 8px">{$children['imageid3']}</div>{$children['label3']}</div>
</div>
EOT;
		return <<<EOT
<div style="float: left">
	{$children['body']}
</div>
<div style="float: left; margin-left: 16px">
	<div>{$children['imageid1']} {$children['label1']}</div>
	<div style="margin-top: 1em">{$children['imageid2']} {$children['label2']}</div>
	<div style="margin-top: 1em">{$children['imageid3']} {$children['label3']}</div>
</div>
EOT;
	}

	static public function to_content($value, $content_id, $page_id)
	{
		if (!$value || !implode($value))
		{
			return;
		}

		return json_encode($value);
	}

	static public function render($contents)
	{
		global $core;

		$values = json_decode($contents, true);

		if (!$values)
		{
			return;
		}

		$values += array
		(
			'body' => null,
			'imageid1' => null,
			'imageid2' => null,
			'imageid3' => null,
			'label1' => null,
			'label2' => null,
			'label3' => null
		);

		$image1 = null;
		$image2 = null;
		$image3 = null;

		if ($values['imageid1'])
		{
			$image1 = $core->models['images'][$values['imageid1']];
			$thumbnail1 = $image1->thumbnail('w:170;h:130;format:png');
			$image1 = new Element('a', array('rel' => 'lightbox[trio]', 'href' => $image1->path, Element::INNER_HTML => $thumbnail1));
		}

		if ($values['imageid2'])
		{
			$image2 = $core->models['images'][$values['imageid2']];
			$thumbnail2 = $image2->thumbnail('w:170;h:130;format:png');
			$image2 = new Element('a', array('rel' => 'lightbox[trio]', 'href' => $image2->path, Element::INNER_HTML => $thumbnail2));
		}

		if ($values['imageid3'])
		{
			$image3 = $core->models['images'][$values['imageid3']];
			$thumbnail3 = $image3->thumbnail('w:170;h:130;format:png');
			$image3 = new Element('a', array('rel' => 'lightbox[trio]', 'href' => $image3->path, Element::INNER_HTML => $thumbnail3));
		}

		return <<<EOT
<div class="well">
<div class="body">{$values['body']}</div>
<div class="illustrations clearfix">
	<div>$image1<br />$values[label1]</div>
	<div>$image2<br />$values[label2]</div>
	<div>$image3<br />$values[label3]</div>
</div>
</div>
EOT;
	}
}